
<%@page import="net.sf.basedb.core.ItemContext.SortDirection"%><%-- $Id: index.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Removable"	
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.core.PermissionDeniedException"	
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.RemovableUtil"
	
	import="java.util.Enumeration"
	import="java.util.HashSet"	
	import="java.util.Set"	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final String subContext = "diskUsage";
	private static final ItemContext defaultContext = 
		Base.createDefaultContext("bytes", "type,name,bytes,location");
	static
	{
		defaultContext.setSortDirection(ItemContext.SortDirection.DESC);
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String viewPage = "view_details.jsp?ID="+ID+"&item_type="+itemType.name();

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		redirect = viewPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = viewPage;
	}
	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the view page
		dc = sc.newDbControl();
		int numTotal = 0;
		int numRemoved = 0;

		Enumeration<String> names = (Enumeration<String>)request.getParameterNames();
		while (names.hasMoreElements())
		{
			String name = names.nextElement();
			if (name.startsWith("item:"))
			{
				Item item = Item.valueOf(name.substring(5));
				Integer[] ids = Values.getInt(request.getParameterValues(name));
				for (int itemId : ids)
				{
					numTotal++;
					try
					{
						BasicItem basicItem = item.getById(dc, itemId);
						Removable r = (Removable)basicItem;
						r.setRemoved(true);
						numRemoved++;
					}
					catch (PermissionDeniedException ex)
					{}
				}
			}
		}
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = viewPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the view page 
		dc = sc.newDbControl();
		int numTotal = 0;
		int numRestored = 0;

		Enumeration<String> names = (Enumeration<String>)request.getParameterNames();
		while (names.hasMoreElements())
		{
			String name = names.nextElement();
			if (name.startsWith("item:"))
			{
				Item item = Item.valueOf(name.substring(5));
				Integer[] ids = Values.getInt(request.getParameterValues(name));
				for (int itemId : ids)
				{
					numTotal++;
					try
					{
						BasicItem basicItem = item.getById(dc, itemId);
						Removable r = (Removable)basicItem;
						r.setRemoved(false);
						numRestored++;
					}
					catch (PermissionDeniedException ex)
					{}
				}
			}
		}
		dc.commit();
		if (numTotal != numRestored)
		{
			message = (numRestored == 0 ? "No" : "Only "+numRestored+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = viewPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ShareItems".equals(cmd))
	{
		// Share all selected items in the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);

		Set<SharedItem> ss = new HashSet<SharedItem>();
		Enumeration<String> names = (Enumeration<String>)request.getParameterNames();
		while (names.hasMoreElements())
		{
			String name = names.nextElement();
			if (name.startsWith("item:"))
			{
				Item item = Item.valueOf(name.substring(5));
				if (SharedItem.class.isAssignableFrom(item.getItemClass()))
				{
					Integer[] ids = Values.getInt(request.getParameterValues(name));
					for (int itemId : ids)
					{
						ss.add((SharedItem)item.getById(dc, itemId));
					}
				}
			}
		}
		if (ss.size() == 0)
		{
			throw new WebException("popup", "No shareable items selected",
				"The items you selected can't be shared.");
		}
		cc.setObject("MultiPermissions", new MultiPermissions(ss));
		dc.close();
		redirect = "../../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subContext;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

