<%-- $Id: edit_hardware.jsp 5506 2010-11-19 09:59:42Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.HARDWARE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Hardware hardware = null;
	boolean readCurrentHardwareType = true;
	int currentHardwareTypeId = 0;

	if (itemId == 0)
	{
		title = "Create hardware";
		cc.removeObject("item");
		currentHardwareTypeId = Values.getInt(request.getParameter("hardwaretype_id"));
		if (currentHardwareTypeId == 0)
		{
			int recentHardwareTypeId = Values.getInt(cc.getRecent(Item.HARDWARETYPE.name(), 0));
			currentHardwareTypeId = Values.getInt(cc.getPropertyValue("hardwareType"), recentHardwareTypeId);
		}
	}
	else
	{
		hardware = Hardware.getById(dc, itemId);
		cc.setObject("item", hardware);
		title = "Edit hardware -- " + HTML.encodeTags(hardware.getName());
		try
		{
			HardwareType ht = hardware.getHardwareType();
			if (ht != null) currentHardwareTypeId = ht.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardwareType = false;
		}
	}
	if (hardware != null && !hardware.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	// Query to retrieve file types
	final ItemQuery<HardwareType> hardwareTypeQuery = HardwareType.getQuery();
	hardwareTypeQuery.order(Orders.asc(Hql.property("name")));
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), hardware);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Hardware" tab
		function validateHardware()
		{
			var frm = document.forms['hardware'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['hardware'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (hardware == null)
			{
				%>
				var frm = document.forms['hardware'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="hardware" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*180)+"px;"%>" 
			position="bottom"  remember="<%=hardware != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Hardware" validate="validateHardware()" helpid="hardware.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(hardware == null ? Values.getString(cc.getPropertyValue("name"), "New hardware") : hardware.getName())%>" 
					size="40" maxlength="<%=Hardware.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Version</td>
				<td><input <%=clazz%> type="text" name="version" 
					value="<%=HTML.encodeTags(hardware == null ? cc.getPropertyValue("versionString") : hardware.getVersionString())%>" 
					size="40" maxlength="<%=Hardware.MAX_VERSIONSTRING_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="hardwaretype_id" 
						<%=!readCurrentHardwareType ? "disabled readonly class=\"disabled\"" : "class=\"required\""%>>
					<%
					if (!readCurrentHardwareType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						for (HardwareType hardwareType : hardwareTypeQuery.list(dc))
						{
							int id = hardwareType.getId();
							%>
							<option value="<%=id == currentHardwareTypeId && hardware != null ? -id : id%>" 
								<%=id == currentHardwareTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(hardwareType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
	
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(hardware == null ? cc.getPropertyValue("description") : hardware.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'hardware', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
