<%-- $Id: view_extract.jsp 5496 2010-11-17 08:09:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemProxy"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.LabeledExtract"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.EXTRACT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

	String title = null;
	Extract extract = Extract.getById(dc, itemId);
	BioMaterialEvent creationEvent = extract.getCreationEvent();
	
	final boolean writePermission = extract.hasPermission(Permission.WRITE);
	final boolean deletePermission = extract.hasPermission(Permission.DELETE);
	final boolean sharePermission = extract.hasPermission(Permission.SET_PERMISSION);
	final boolean usePermission = extract.hasPermission(Permission.USE);
	final boolean setOwnerPermission = extract.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = extract.isRemoved();
	final boolean isUsed = isRemoved && extract.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = extract.isOwner();	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, extract);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareExtract', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function viewEvents()
		{
			location.href = '../events/index.jsp?ID=<%=ID%>&cmd=List&biomaterial_id=<%=itemId%>&biomaterial_type=<%=itemType.name()%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if ((tabId == 'overview' || tabId == 'history') && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'events')
			{
				viewEvents();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newLabeledExtract()
		{
			Main.viewOrEditItem('<%=ID%>', 'LABELEDEXTRACT', 0, true, '&extract_id=<%=itemId%>')
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Extracts" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(extract.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this extract" : "You do not have permission to edit this extract"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!extract.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this extract" : "You do not have permission to delete this extract"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=extract.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this extract" : "You do not have permission to restore this extract"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this extract to other user, groups and projects" : "You do not have permission to share this extract"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button
				image="add.png"
				onclick="newLabeledExtract()"
				title="New labeled extract&hellip;"
				tooltip="Create a new labeled extract from this extract"
				visible="<%=sc.hasPermission(Permission.CREATE, Item.LABELEDEXTRACT) && usePermission %>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'extract.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(extract)%></i></div>
			<%
			if (extract.isRemoved() || extract.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=extract.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(extract.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><%=HTML.encodeTags(extract.getExternalId())%></td>
			</tr>
			<tr>
				<td class="prompt">Created</td>
				<td><%=dateFormatter.format(creationEvent.getEventDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(creationEvent.getEntryDate())%></td>
			</tr>
			<%
			if (!extract.isPooled())
			{
				%>
				<tr>
					<td class="prompt">Sample</td>
					<td><base:propertyvalue item="<%=extract%>" property="parent"/>	
						<%
						try
						{
						%>
							<%=extract.getSample() != null ? "(" + Values.formatNumber(creationEvent.getUsedQuantity(extract.getSample()), 2, " µg") + ")" : ""%>
						<%
						}
						catch (PermissionDeniedException ex)
						{}
						%>	

					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Protocol</td>
				<td><base:propertyvalue item="<%=creationEvent%>" property="protocol"/></td>
			</tr>
			<tr>
				<td class="prompt">Original quantity</td>
				<td><%=Values.formatNumber(extract.getOriginalQuantity(), 2, " µg")%></td>
			</tr>
			<tr>
				<td class="prompt">Remaining quantity</td>
				<td><%=Values.formatNumber(extract.getRemainingQuantity(), 2, " µg")%></td>
			</tr>
			<tr>
				<td class="prompt">Bioplate</td>
				<td>
					<base:propertyvalue item="<%=extract%>" property="bioWell.bioPlate" />
					<%
					try
					{
						BioWell well = extract.getBioWell();
						if (well != null)
						{
							%>
							[<%=rowFormatter.format(well.getRow())%>,<%=columnFormatter.format(well.getColumn())%>]
							<base:icon image="locked.gif"  visible="<%=extract.isLockedInWell()%>"/>
						<%
						}
					}
					catch (PermissionDeniedException ex)
					{}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=extract%>" property="owner"/></td>
			</tr>
			<tr valign="baseline">
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(extract.getDescription())%></td>
			</tr>
			</table>
	
			<%
			if (extract.isPooled())
			{
				ItemQuery<Extract> extractsQuery = (ItemQuery<Extract>)creationEvent.getSources();
				extractsQuery.include(Include.ALL);
				extractsQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<Extract> extracts = extractsQuery.list(dc);
				%>
				<h4 class="docked">Pooled from extracts</h4>
				<tbl:table
					id="pooled"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="quantity"
					title="Used quantity (µg)"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (Extract item : extracts)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="quantity"><%=Values.formatNumber(creationEvent.getUsedQuantity(item), 2)%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}

			// Extracts this item is pooled in.
			ItemQuery<BioMaterialEvent> poolingQuery = extract.getPoolingEvents();
			ItemResultList<BioMaterialEvent> poolingEvents = poolingQuery.list(dc);
			if (poolingEvents.size() == 0)
			{
				%>
				<h4>Pooled in extracts</h4>
				No extracts have been pooled from this extract
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="pooledSection" 
					title="<%="Pooled in extracts (" + poolingEvents.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="poolChilds"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="quantity"
							title="Original quantity (µg)"
						/>
						<tbl:columndef 
							id="parents"
							title="Used extracts[quantity]" 
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:columns></tbl:columns>
							<tbl:rows>
							<%
							for (BioMaterialEvent poolEvt : poolingEvents)
							{
								ItemQuery<Extract> extractsQuery = (ItemQuery<Extract>)poolEvt.getSources();
								Extract child = (Extract)poolEvt.getBioMaterial();
								extractsQuery.include(Include.ALL);
								extractsQuery.order(Orders.asc(Hql.property("name")));
								ItemResultList<Extract> parentExtracts = extractsQuery.list(dc);
								%>
								<tbl:row>
									<tbl:cell column="name">
										<base:icon 
											image="deleted.gif" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=child.isRemoved()%>"
										/>
										<%=Base.getLinkedName(ID, child, false, true)%>
									</tbl:cell>
									<tbl:cell column="quantity"><%=Values.formatNumber(child.getOriginalQuantity(), 2)%></tbl:cell>
									<tbl:cell column="parents">
									<%
									String separator = "";
									for (Extract parent : parentExtracts)
									{
										out.write(separator);
										if (parent.equals(extract))
												out.write(HTML.encodeTags(parent.getName()));
										else										
											out.write(Base.getLinkedName(ID, parent, false, true));
										out.write("[" + Values.formatNumber(poolEvt.getUsedQuantity(parent), 2) + "µg]");
										separator = ", ";
									}
									%>
									</tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(child.getDescription())%></tbl:cell>
								</tbl:row>
								<%
							}
							%>						
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
				
			ItemQuery<LabeledExtract> labeledExtractQuery = LabeledExtract.getQuery();
			labeledExtractQuery.include(Include.ALL);
			labeledExtractQuery.restrict(Restrictions.eq(Hql.property("parent"), Expressions.parameter("extracts")));
			labeledExtractQuery.setParameter("extracts", itemId, Type.INT);
			labeledExtractQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<LabeledExtract> labeledExtracts = labeledExtractQuery.list(dc);
			
			if (labeledExtracts.size() == 0)
			{
				%>
				<h4>Labeled extracts</h4>
				No labeled extracts have been created from this extract
				(or you don't have the permission to view them)
				<%
			}
			else
			{
				%>
				<base:section 
					id="labeledExtractSection" 
					title="<%="Labeled extracts (" + labeledExtracts.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="labeledextracts"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef
							id="name"
							title="Name"
						/>					
						<tbl:columndef 
							id="quantity"
							title="Used quantity (µg)"
						/>
						<tbl:columndef
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:columns></tbl:columns>
							<tbl:rows>
								<%
								for (LabeledExtract lbe : labeledExtracts)
								{
									%>
									<tbl:row>
										<tbl:cell column="name"><base:icon 
											image="deleted.gif" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=lbe.isRemoved()%>"
										/><%=Base.getLinkedName(ID, lbe, false, true)%></tbl:cell>
										<tbl:cell column="quantity"><%=Values.formatNumber(lbe.getCreationEvent().getUsedQuantity(extract), 2)%></tbl:cell>
										<tbl:cell column="description"><%=HTML.encodeTags(lbe.getDescription())%></tbl:cell>
									</tbl:row>
									<%
								}
								%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}			
			%>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this extract" />
			</jsp:include>
			<%
			MultiPermissions mp = new MultiPermissions(Collections.singleton(extract));
			ItemResultList<User> users = mp.getUsers().list(dc);
			ItemResultList<Group> groups = mp.getGroups().list(dc);
			ItemResultList<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section 
					id="sharedTo" 
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)
							{
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This extract is not shared 
				(or, you don't have permission to view the ones it is shared to).				
				<%
			}			
			%>
			
		</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations &amp; parameters" 
				tooltip="View annotation values and protocol parameters">
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			
			<t:tab id="events" title="Events" />

			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<%
				if ("overview".equals(tab))
				{
					%>
					<jsp:include page="../../common/overview/overview.jsp">
						<jsp:param name="item_type" value="<%=itemType.name()%>" />
						<jsp:param name="item_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>			
			</t:tabcontrol>


	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
