<%-- $Id: edit_sample.jsp 5490 2010-11-15 12:53:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.SAMPLE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Sample sample = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	boolean isPooled = false;
	String name = null;
	boolean lockEventProperties = false;

	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	Protocol defaultProtocol = null;
	boolean readCurrentBioSource = true;
	BioSource currentBioSource = null;
	ItemQuery<Sample> samplesQuery = null;	
	boolean readCurrentBioWell = true;
	BioWell currentBioWell = null;
	boolean lockedWell = false;
	boolean readCurrentBioPlate = true;
	BioPlate currentBioPlate = null;
	
	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<BioSource> recentBioSources = (List<BioSource>)cc.getRecent(dc, Item.BIOSOURCE);
	List<BioPlate> recentBioPlates = (List<BioPlate>)cc.getRecent(dc, Item.BIOPLATE);
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultProtocol = (Protocol)activeProject.getDefaultItem(dc, Project.Default.SAMPLING_PROTOCOL);
		}
		catch(PermissionDeniedException pdex)
		{
			defaultProtocol = null;
		}
	}
		

	if (itemId == 0)
	{
		title = "Create sample";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		int bioSourceId = Values.getInt(request.getParameter("biosource_id"));
		if (bioSourceId != 0)
		{
			currentBioSource = BioSource.getById(dc, bioSourceId);
			isPooled = false;
			name = currentBioSource.getName() + ".s" + (currentBioSource.countSamples() + 1);
		}
		else if (Values.getBoolean(request.getParameter("pooled")))
		{		
			isPooled = true;
			name = Values.getString(cc.getPropertyValue("name"),"New pooled sample");
		}
		else
		{
			isPooled = Values.getBoolean(cc.getPropertyValue("pooled"));
			name = Values.getString(cc.getPropertyValue("name"), "New sample");
		}
		eventDate = (Date)cc.getPropertyObject("creationEvent.eventDate");
	}
	else
	{
		sample = Sample.getById(dc, itemId);
		cc.setObject("item", sample);
		title = "Edit sample -- " + HTML.encodeTags(sample.getName());
	
		creationEvent = sample.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		isPooled = sample.isPooled();
		name = sample.getName();
		lockEventProperties = !creationEvent.hasPermission(Permission.WRITE);
		
		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
	
		try
		{
			currentBioSource = sample.getBioSource();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioSource = false;
		}
		
		try
		{
			currentBioWell = sample.getBioWell();
			lockedWell = sample.isLockedInWell();
			if (currentBioWell != null)
			{
				currentBioPlate = currentBioWell.getPlate();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioWell = false;
			readCurrentBioPlate = false;
		}
	
		// Query to retrieve pooled samples
		samplesQuery = (ItemQuery<Sample>)creationEvent.getSources();
		samplesQuery.include(Include.ALL);
		samplesQuery.order(Orders.asc(Hql.property("name")));
	
	}
	if (sample != null && !sample.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), sample);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Sample" tab
		function validateSample()
		{
			var frm = document.forms['sample'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (Main.trimString(frm.bioplate_id.value) != 0 && Main.trimString(frm.biowell_id.value) == 0)
			{
				alert("You must choose a biowell from the bioplate");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['sample'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.modifiedSamples.value = Link.exportModified(frm, 'S', true).join(',');
				frm.removedSamples.value = Link.getActionIds(-1, 'S').join(',');
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['sample'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}
		
		function getParents()
		{
			var frm = document.forms['sample'];
			var parents = new Array();
			if (frm.pooled[0].checked)
			{
				var bioSourceId = Math.abs(parseInt(frm.biosource_id[frm.biosource_id.selectedIndex].value));
				if (bioSourceId > 0) parents[parents.length] = 'BIOSOURCE:'+bioSourceId;
			}
			else
			{
				var ids = Link.getListIds(frm.samples, 'S');
				if (ids.length > 0)
				{
					parents[parents.length] = 'SAMPLE:'+ids.join(':');
				}
			}
			return parents;
		}
		
		function selectProtocolOnClick()
		{
			var frm = document.forms['sample'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:protocolType=<%=SystemItems.getId(ProtocolType.SAMPLING)%>';
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}

		function selectBioPlateOnClick()
		{
			var frm = document.forms['sample'];
			var url = '../bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioPlateCallback';
			if (frm.bioplate_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.bioplate_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:bioPlateType.lockMode=<><%=BioWell.LockMode.LOCKED_AFTER_CREATE.getValue()%>';
			url += '&tmpfilter:BOOLEAN:destroyed=false';
			Main.openPopup(url, 'SelectBioplate', 1000, 700);
		}	
		function setBioPlateCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.bioplate_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			frm.biowell_id.remove(1);
			frm.biowell_id.disabled = false;
		}
		function bioPlateOnChange()
		{
			var frm = document.forms['sample'];
			var list = frm.bioplate_id;
			frm.biowell_id.selectedIndex=0;
			frm.biowell_id.remove(1);			
		}

		function initBioWell()
		{
			var frm = document.forms['sample'];
			<%
			if (currentBioWell != null)
			{
				%>
				var list = frm.biowell_id;
				var wellId = <%=currentBioWell.getId()%>;
				Forms.addListOption(list, 1, new Option());
				list[1].value = '<%=currentBioWell.getId()*(sample == null ? 1 : -1)%>';
				list[1].text = '[<%=rowFormatter.format(currentBioWell.getRow())%>,<%=columnFormatter.format(currentBioWell.getColumn())%>]';
				list.selectedIndex = 1;
			<%
			}
			%>
		}					
		function selectBioWellOnClick()
		{
			var frm = document.forms['sample'];
			var bioplate_list = frm.bioplate_id;			
			var bioplateId = Math.abs(parseInt(bioplate_list[bioplate_list.selectedIndex].value))
			if (Main.trimString(frm.bioplate_id.value) == 0)
			{
				alert("You must first select the bioplate where the biowell is located");
				return;
			}			
				
			var url = '../bioplates/wells/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioWellCallback';
			if (frm.biowell_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.biowell_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&bioplate_id='+bioplateId;
			url += '&resetTemporary=1&tmpfilter:STRING:$mbm.name='+escape('=');
			url += '&tmpfilter:STRING:originalBioMaterial.name='+escape('=');
			url += '&columns=row,column';
			Main.openPopup(url, 'SelectBiowell', 700, 700);
		}
		function setBioWellCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.biowell_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function pooledOnClick()
		{
			var frm = document.forms['sample'];
			var isPooled = frm.pooled[1].checked
			frm.biosource_id.disabled = isPooled;
			frm.samples.disabled = !isPooled;
			frm.used_quantity.disabled = !isPooled;
			parentsChanged = true;
		}
		function bioSourceOnChange()
		{
			parentsChanged = true;
		}
		function selectBioSourceOnClick()
		{
			var frm = document.forms['sample'];
			if (frm.pooled[1].checked)
			{
				alert('This is a pooled sample, which cannot have a biosource as it\'s parent');
				return;
			}
			var url = '../biosources/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioSourceCallback';
			if (frm.biosource_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.biosource_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectBioSource', 1000, 700);
		}
		function setBioSourceCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.biosource_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			parentsChanged = true;
		}
		
		function addSamplesOnClick()
		{
			var frm = document.forms['sample'];
			if (!frm.pooled[1].checked)
			{
				alert('This is not a pooled sample');
				return;
			}
			Main.openPopup('index.jsp?ID=<%=ID%>&mode=selectmultiple&callback=addSampleCallback', 'AddSamples', 1000, 700);
		}
		function addSampleCallback(sampleId, name)
		{
			var item = Link.getItem('S', sampleId);
			if (!item) item = new Item('S', sampleId, name+' [-]', '', '');
			Link.addItem(document.forms['sample'].samples, item);
			parentsChanged = true;
		}
		function samplesOnChange()
		{
			var frm = document.forms['sample'];
			var item = frm.samples[frm.samples.selectedIndex].item;
			if (item && item.id)
			{
				frm.used_quantity.value = item.value;
				frm.used_quantity.focus();
			}
			else
			{
				frm.used_quantity.value = '';
			}
		}
		function usedQuantityOnBlur()
		{
			var frm = document.forms['sample'];
			var usedQuantity = frm.used_quantity.value;
			var displayQuantity = usedQuantity == '' ? '-' : usedQuantity+' µg';
			for (var i = 0; i < frm.samples.length; i++)	// >
			{
				var option = frm.samples[i];
				if (option.selected && option.item.id)
				{
					option.item.value = usedQuantity;
					var text = option.text.replace(/\[.*\]/, '['+displayQuantity+']');
					option.text = text; 
				}
			}
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['sample'].samples);
			parentsChanged = true;
		}

		function init()
		{
			<%
			if (sample == null)
			{
				%>
				var frm = document.forms['sample'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initBioWell();
			initSamples();
			pooledOnClick();		
		}
		function initSamples()
		{
			var samples = document.forms['sample'].samples;
			<%
			if (sample != null && sample.isPooled())
			{
				ItemResultList<Sample> samples = samplesQuery.list(dc);
				for (Sample s : samples)
				{
					String usedQuantity = Values.formatNumber(creationEvent.getUsedQuantity(s), -1);
					%>
					Link.addNewItem(samples, new Item('S', <%=s.getId()%>, '<%=HTML.javaScriptEncode(s.getName())%> [<%=usedQuantity%> µg]', '<%=usedQuantity%>'));
					<%
				}
			}
			else if (sample == null && Values.getBoolean(request.getParameter("pooled")))
			{
				for (int sid : cc.getSelected())
				{
					Sample sampleToPool = Sample.getById(dc, sid);
					%>
					Link.addItem(samples, new Item('S', <%=sampleToPool.getId()%>, '<%=HTML.javaScriptEncode(sampleToPool.getName())%> [-]', '', ''));
					<%
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="sample" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=sample != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Sample" validate="validateSample()" helpid="sample.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=Sample.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(sample == null ? Values.getString(cc.getPropertyValue("externalId"), "") : sample.getExternalId())%>" 
					size="40" maxlength="<%=Sample.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Original quantity</td>
				<td><input <%=clazz%> type="text" name="original_quantity" 
					value="<%=Values.formatNumber(sample == null ? Values.getFloat(cc.getPropertyValue("originalQuantity"), null): sample.getOriginalQuantity(), -1)%>" size="12" 
					maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
			</tr>
			<tr>
				<td class="prompt">Created</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" <%=lockEventProperties ? "disabled" : ""%>
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Created', 'sample', 'event_date', null, '"+jsDateFormat+"')"%>"
						image="calendar.png" 
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
						disabled="<%=lockEventProperties%>"
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitem="<%=defaultProtocol%>"
						newitem="<%=sample == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
						disabled="<%=lockEventProperties %>"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Bioplate</td>
				<td>
					<base:select 
						id="bioplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioPlate%>"
						denied="<%=!readCurrentBioPlate%>"
						recent="<%=recentBioPlates%>"
						newitem="<%=sample == null%>"
						onselect="selectBioPlateOnClick()"
						onchange="bioPlateOnChange()"
						disabled="<%=lockedWell%>"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Biowell</td>
				<td>
					<base:select 
						id="biowell_id"
						clazz="selectionlist"
						required="false"						
						current="<%=null %>"
						denied="<%=!readCurrentBioWell%>"
						newitem="<%=sample == null%>"
						onselect="selectBioWellOnClick()"
						onchange="bioWellOnChange()"
						disabled="<%=lockedWell%>"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(sample == null ? cc.getPropertyValue("description") : sample.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'sample', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="parents" title="Parents" helpid="sample.parents" >
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Pooled</td>
				<td>
					<input type="radio" name="pooled" value="0" onclick="pooledOnClick()"
						<%=!isPooled ? "checked" : ""%>
						>no
					<input type="radio" name="pooled" value="1" onclick="pooledOnClick()"
						<%=isPooled ? "checked" : ""%>
						>yes
				</td>
			</tr>
			<tr>
				<td class="prompt">Biosource</td>
				<td>
					<base:select 
						id="biosource_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioSource%>"
						denied="<%=!readCurrentBioSource%>"
						recent="<%=recentBioSources%>"
						selectrecent="false"
						newitem="<%=sample == null%>"
						onselect="selectBioSourceOnClick()"
						onchange="bioSourceOnChange()"
					/>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Samples</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="samples" size="5" multiple style="width: 20em;" 
							onchange="samplesOnChange()"
						</select>&nbsp;<br>
						Used
						<input <%=clazz%> type="text" name="used_quantity" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="usedQuantityOnBlur();"
						> (µg)
						<input type="hidden" name="modifiedSamples" value="">
						<input type="hidden" name="removedSamples" value="">
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							onclick="addSamplesOnClick()" 
							title="Add&nbsp;samples&hellip;" 
							tooltip="Add samples"
							/></td></tr>
						<tr><td width="150"><base:button 
							onclick="removeOnClick()" 
							title="Remove" 
							tooltip="Remove the selected samples"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
