<%-- $Id: edit_project.jsp 5574 2011-02-18 12:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionTemplate"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.EnumSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getPermissionString(Set<Permission> permissions)
{
	StringBuilder sb = new StringBuilder();
	sb.append(permissions.contains(Permission.READ) ? "R" : "-");
	sb.append(permissions.contains(Permission.USE) ? "U" : "-");
	sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
	sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
	sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
	sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
	return sb.toString();
}
%>
<%
final Item itemType = Item.PROJECT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Project project = null;
	
	// Query to retrieve child groups
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve user members
	ItemQuery<User> userQuery = null;
	
	// Load recently used items
	List<Protocol> recentProtocol = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Software> recentSoftware = (List<Software>)cc.getRecent(dc, Item.SOFTWARE);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);
	List<ArrayDesign> recentArrayDesign = (List<ArrayDesign>)cc.getRecent(dc, Item.ARRAYDESIGN);
	
	boolean deniedPlatform = false;
	Platform currentPlatform = null;
	PlatformVariant currentVariant = null;
	RawDataType currentRawDataType = null;
	boolean readCurrentPermissionTemplate = true;
	PermissionTemplate currentPermissionTemplate = null;

	List<PermissionTemplate> recentPermissionTemplates = (List<PermissionTemplate>)cc.getRecent(dc, Item.PERMISSIONTEMPLATE);

	if (itemId == 0)
	{
		title = "Create project";
		cc.removeObject("item");
		currentPermissionTemplate = Base.getFirstMatching(dc, PermissionTemplate.getQuery(), "name", cc.getPropertyFilter("permissionTemplate.name"));
	}
	else
	{
		project = Project.getById(dc, itemId);
		cc.setObject("item", project);
		title = "Edit project -- " + HTML.encodeTags(project.getName());
		currentRawDataType = project.getDefaultRawDataType();
		
		try
		{
			currentPlatform = (Platform)project.getDefaultItem(dc, Project.Default.PLATFORM);
			currentVariant = (PlatformVariant)project.getDefaultItem(dc, Project.Default.PLATFORM_VARIANT);
			if (currentRawDataType != null)
			{
				if (currentPlatform == null) currentPlatform = currentRawDataType.getPlatform(dc);
				if (currentVariant == null) currentVariant = currentRawDataType.getVariant(dc);
			}
		}
		catch (PermissionDeniedException ex)
		{
			deniedPlatform = true;
		}
		
		if (currentRawDataType == null && currentVariant != null) currentRawDataType = currentVariant.getRawDataType();
		if (currentRawDataType == null && currentPlatform != null) currentRawDataType = currentPlatform.getRawDataType();
		if (currentRawDataType == null) currentRawDataType = project.getDefaultRawDataType();
	
		try
		{
			currentPermissionTemplate = project.getPermissionTemplate();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPermissionTemplate = false;
		}
	
		groupQuery = project.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		userQuery = project.getUsers();
		userQuery.include(Include.ALL);
		userQuery.order(Orders.asc(Hql.property("name")));
	}
	if (project != null && !project.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(Include.ALL);
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	ItemResultList<Platform> platforms = platformQuery.list(dc);

	ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(Include.ALL);
	variantQuery.order(Orders.asc(Hql.property("name")));
	variantQuery.setCacheResult(true);
	ItemResultList<PlatformVariant> variants = variantQuery.list(dc);
	
	Set<Project.Default> ignore = EnumSet.of(
		Project.Default.PLATFORM, Project.Default.PLATFORM_VARIANT, 
		Project.Default.RAW_DATA_TYPE);
	
	final StringBuilder sb = new StringBuilder();	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), project);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js,parameters.js,platforms.js" styles="tabcontrol.css,parameters.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Project" tab
		function validateProject()
		{
			var frm = document.forms['project'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Members" tab
		function validateMembers()
		{
			return true;
		}
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['project'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.modifiedUsers.value = Link.exportModified(frm, 'U').join(',');
				frm.modifiedGroups.value = Link.exportModified(frm, 'G').join(',');
				frm.submit();
			}
		}

		function init()
		{
			var frm = document.forms['project'];
			<%
			if (project == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initPlatforms(<%=currentPlatform == null ? 0 : currentPlatform.getId()%>, <%=currentVariant == null ? 0 : currentVariant.getId()%>);
			initMembers();
			initDefaults();
			platformOnChange();
			permissionTemplateOnChange();
			showPermissions(frm.autoPermissions.value, 'auto_');
		}
		function initPlatforms(platformId, variantId)
		{
			<%
			for (Platform p : platforms)
			{
				if (!p.isRemoved() || p.equals(currentPlatform))
				{
					RawDataType rdt = p.isFileOnly() ? null : p.getRawDataType();
					%>
					var p<%=p.getId()%> = new Platform(<%=p.getId()%>, '<%=HTML.javaScriptEncode(p.getExternalId())%>', '<%=HTML.javaScriptEncode(p.getName())%>', <%=p.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			for (PlatformVariant v : variants)
			{
				Platform p = v.getPlatform();
				if ((!v.isRemoved() || v.equals(currentVariant)) && (!p.isRemoved() || p.equals(currentPlatform)))
				{
					RawDataType rdt = v.isFileOnly() ? null : v.getRawDataType();
					%>
					var v<%=v.getId()%> = new Variant(p<%=p.getId()%>, <%=v.getId()%>, '<%=HTML.javaScriptEncode(v.getExternalId())%>', '<%=HTML.javaScriptEncode(v.getName())%>', <%=v.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			%>
			var frm = document.forms['project'];
			Platforms.populateList(frm.platform, platformId, variantId);
		}
		function initDefaults()
		{
			<%
			// Platform/variant/raw data type
			String icon = currentPlatform == null && currentVariant == null && currentRawDataType == null ? 
				"notrequired_novalues.gif" : "notrequired_values.gif";
			icon = "<span class=\"icon\"><img id=\"icon_default_platform\" src=\"../../images/"+icon+"\"></span>";
			sb.append("<div class=\"param\" id=\"prompt_default_platform\" onclick=\"defaultItemOnClick('default_platform')\"");
			sb.append(" onmouseover=\"Main.addClass(this, 'hover')\" onmouseout=\"Main.removeClass(this, 'hover')\" title=\"Platform / raw data type\">");
			sb.append(icon+"<span class=\"label\">Platform / raw data type</span></div>\n");
			for (Project.Default d : Project.Default.values())
			{
				%>
				var values = new Array();
				<%
				icon = "";
				if (project != null)
				{
					if (d.getItemType() != null)
					{
						BasicItem defaultValue = project.getDefaultItem(dc, d);
						int valueId = 0;
						if (defaultValue != null)
						{
							valueId = defaultValue.getId();
							icon = "notrequired_values.gif";
						}
						else
						{
							icon = "notrequired_novalues.gif";
						}
						%>
						values[values.length] = <%=valueId%>;
						<%
					}
					else if (d == Project.Default.RAW_DATA_TYPE)
					{
						RawDataType rdt = project.getDefaultRawDataType();
						String strValueId = "";
						if (rdt != null)
						{
							strValueId = rdt.getId();
							icon = "notrequired_values.gif";
						}
						else
						{
							icon = "notrequired_novalues.gif";
						}
						%>
						values[values.length] = '<%=strValueId%>';
						<%
					}
				}
				else
				{
					icon = "notrequired_novalues.gif";
				}
				if (!ignore.contains(d))
				{
					icon = "<span class=\"icon\"><img id=\"icon_"+d.getName()+"\" src=\"../../images/"+icon+"\"></span>";
					sb.append("<div class=\"param\" id=\"prompt_"+d.getName()+"\" onclick=\"defaultItemOnClick('"+d.getName()+"')\"");
					sb.append(" onmouseover=\"Main.addClass(this, 'hover')\" onmouseout=\"Main.removeClass(this, 'hover')\" title=\""+d.getShortName()+"\">");
					sb.append(icon+"<span class=\"label\">"+d.getShortName()+"</span></div>\n");				
				}
				%>
				var di = new Parameter('<%=d.getName()%>', '<%=HTML.javaScriptEncode(d.getShortName())%>', 1, false, false, values);
				<%
			}
			%>
		}
		function initMembers()
		{
			var frm = document.forms['project'];
			var members = frm.members;
			Link.addNewSection(members, new Section('U', 'Users'));
			<%
			if (userQuery != null)
			{
				ItemResultList<User> users = userQuery.list(dc);
				for (User user : users)
				{
					Set<Permission> permissions = project.getPermissions(user);
					%>
					Link.addNewItem(members, new Item('U',<%=user.getId()%>, '<%=HTML.javaScriptEncode(user.getName())%> [<%=getPermissionString(permissions)%>]', <%=PermissionUtil.getPermissionCode(permissions)%>));
					<%
				}
			}
			%>
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			if (groupQuery != null)
			{
				ItemResultList<Group> groups = groupQuery.list(dc);
				for (Group group : groups)
				{
					Set<Permission> permissions = project.getPermissions(group);
					%>
					Link.addNewItem(members, new Item('G',<%=group.getId()%>, '<%=HTML.javaScriptEncode(group.getName())%> [<%=getPermissionString(permissions)%>]', <%=PermissionUtil.getPermissionCode(permissions)%>));
					<%
				}
			}
			%>
		}			
		function correctPermissions(checked, prefix)
		{
			if (!prefix) prefix = '';
			var frm = document.forms['project'];
			if (checked)
			{
				frm[prefix+'set_permission'].checked = frm[prefix+'set_permission'].checked;
				frm[prefix+'set_owner'].checked = frm[prefix+'set_owner'].checked;
				frm[prefix+'delete'].checked = frm[prefix+'delete'].checked ;
				frm[prefix+'write'].checked = frm[prefix+'write'].checked || frm[prefix+'delete'].checked || frm[prefix+'set_owner'].checked || frm[prefix+'set_permission'].checked;
				frm[prefix+'use'].checked = frm[prefix+'use'].checked || frm[prefix+'write'].checked;
				frm[prefix+'read'].checked = frm[prefix+'read'].checked || frm[prefix+'use'].checked;
			}
			else
			{
				frm[prefix+'read'].checked = frm[prefix+'read'].checked;
				frm[prefix+'use'].checked = frm[prefix+'use'].checked && frm[prefix+'read'].checked;
				frm[prefix+'write'].checked = frm[prefix+'write'].checked && frm[prefix+'use'].checked;
				frm[prefix+'delete'].checked = frm[prefix+'delete'].checked && frm[prefix+'write'].checked;
				frm[prefix+'set_owner'].checked = frm[prefix+'set_owner'].checked && frm[prefix+'write'].checked;
				frm[prefix+'set_permission'].checked = frm[prefix+'set_permission'].checked && frm[prefix+'write'].checked;
			}
		}
		function getPermissionCode(prefix)
		{
			if (!prefix) prefix = '';
			var permissionCode = 0;
			var frm = document.forms['project'];
			permissionCode += frm[prefix+'read'].checked ? <%=READ_CODE%>: 0;
			permissionCode += frm[prefix+'use'].checked ? <%=USE_CODE%>: 0;
			permissionCode += frm[prefix+'write'].checked ? <%=WRITE_CODE%>: 0;
			permissionCode += frm[prefix+'delete'].checked ? <%=DELETE_CODE%>: 0;
			permissionCode += frm[prefix+'set_owner'].checked ? <%=SET_OWNER_CODE%>: 0;
			permissionCode += frm[prefix+'set_permission'].checked ? <%=SET_PERMISSION_CODE%>: 0;
			return permissionCode;
		}
		function getPermissionString(permissionCode)
		{
			var s = '';
			s += permissionCode & <%=READ_CODE%> ? "R" : "-";
			s += permissionCode & <%=USE_CODE%> ? "U" : "-";
			s += permissionCode & <%=WRITE_CODE%> ? "W" : "-";
			s += permissionCode & <%=DELETE_CODE%> ? "D" : "-";
			s += permissionCode & <%=SET_OWNER_CODE%> ? "O" : "-";
			s += permissionCode & <%=SET_PERMISSION_CODE%> ? "P" : "-";
			return s;
		}
		function showPermissions(permissionCode, prefix)
		{
			if (!prefix) prefix = '';
			var frm = document.forms['project'];
			frm[prefix+'read'].checked = permissionCode & <%=READ_CODE%>;
			frm[prefix+'use'].checked = permissionCode & <%=USE_CODE%>;
			frm[prefix+'write'].checked = permissionCode & <%=WRITE_CODE%>;
			frm[prefix+'delete'].checked = permissionCode & <%=DELETE_CODE%>;
			frm[prefix+'set_owner'].checked = permissionCode & <%=SET_OWNER_CODE%>;
			frm[prefix+'set_permission'].checked = permissionCode & <%=SET_PERMISSION_CODE%>;
		}
		
		function permissionsOnClick(name)
		{
			var frm = document.forms['project'];
			var radio = frm[name];
			correctPermissions(radio.checked);
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			for (var i = 0; i < frm.members.length; i++)	// >
			{
				var option = frm.members[i];
				if (option.selected && option.item.id)
				{
					option.item.value = permissionCode;
					var text = option.text.replace(/\[.*\]/, '['+permissionString+']');
					option.text = text; 
				}
			}
		}
		
		function autoPermissionsOnClick(name)
		{
			var frm = document.forms['project'];
			var radio = frm[name];
			correctPermissions(radio.checked, 'auto_');
			frm.autoPermissions.value = getPermissionCode('auto_');
		}

		function selectPermissionTemplateOnClick()
		{
			var frm = document.forms['project'];
			var url = '../../views/permissiontemplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPermissionTemplateCallback';
			if (frm.permissiontemplate_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.permissiontemplate_id[1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectPermissionTemplate', 1000, 700);
		}
		function setPermissionTemplateCallback(id, name)
		{
			var frm = document.forms['project'];
			var list = frm.permissiontemplate_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			permissionTemplateOnChange();
		}
		function permissionTemplateOnChange()
		{
			var frm = document.forms['project'];
			var hasTemplate = frm.permissiontemplate_id.selectedIndex > 0;
			frm.auto_read.disabled = hasTemplate;
			frm.auto_use.disabled = hasTemplate;
			frm.auto_write.disabled = hasTemplate;
			frm.auto_delete.disabled = hasTemplate;
			frm.auto_set_owner.disabled = hasTemplate;
			frm.auto_set_permission.disabled = hasTemplate;
		}
		function membersOnChange()
		{
			var frm = document.forms['project'];
			var item = frm.members[frm.members.selectedIndex].item;
			if (item && item.id)
			{
				showPermissions(item.value);
			}
			else
			{
				showPermissions(0);
			}
		}

		function addUsersOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].members, 'U');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addUserCallback&permission=READ&exclude='+excludes, 'AddUsers', 1000, 700);
		}
		function addUserCallback(userId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('U', userId);
			if (!item) item = new Item('U', userId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['project'].members, item);
		}
		function addGroupsOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].members, 'G');
			<%
			if (!sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE))
			{
				%>
				ids[ids.length] = '<%=SystemItems.getId(Group.EVERYONE)%>';
				<%
			}
			%>
			var excludes = ids.join(',');
			Main.openPopup('../../admin/groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback&permission=READ&exclude='+excludes, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['project'].members, item);
		}
		var oldValueDiv;
		function defaultItemOnClick(defaultName)
		{
			var frm = document.forms['project'];
			if (oldValueDiv) Main.hide(oldValueDiv);
			
			var pp = Parameters.allParameters['ID'+defaultName];
			setSelectedParameter(pp, defaultName);
			oldValueDiv = 'value_'+pp.name+'_div';
			Main.show(oldValueDiv);
		}	
		var selectedParameter = null;
		var selectedParameterName = null;
		function getSelectedParameter()
		{
			return selectedParameter;
		}		
		function setSelectedParameter(parameter, name)
		{
			if (selectedParameter != null)
			{
				Main.removeClass(document.getElementById('prompt_'+selectedParameter.name), 'selected');
			}
			selectedParameter = parameter;
			selectedParameterName = name;
			if (selectedParameter != null)
			{
				Main.addClass(document.getElementById('prompt_'+selectedParameter.name), 'selected');
			}
		}
		function updateSelectedStyle()
		{
			var pp = getSelectedParameter();
			var icon = document.getElementById('icon_'+pp.name);
			var gif = getRoot()+'images/';
			if (pp.values[0] == 0)
			{
				gif += 'notrequired_novalues.gif';
			}
			else
			{
				gif += 'notrequired_values.gif';
			}
			icon.src = gif;		
		}
		function defaultValueOnChange(value)
		{
			var pp = getSelectedParameter();
			if (value == null || value == '')
			{
				pp.removeValue(0);
			}
			else
			{
				pp.updateValue(0, value);
			}	
			updateSelectedStyle();		
		}		
		function selectDefaultItemOnClick(url)
		{
			var frm = document.forms['project'];						
			var select_id = 'value_' + getSelectedParameter().name;
			var selectlist = frm[select_id];
			if (selectlist.length > 1)
			{
				var id = Math.abs(parseInt(selectlist[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectDefaultItem', 1000, 700);
		}
		function setDefaultItemCallback(id, name)
		{
			var frm = document.forms['project'];
			var select_id = 'value_' + getSelectedParameter().name;
			var selectlist = frm[select_id];
			if (selectlist.length < 2)
			{
				Forms.addListOption(selectlist, 1, new Option());
			}
			selectlist[1].value = id;
			selectlist[1].text = name;
			selectlist.selectedIndex = 1;	
			defaultValueOnChange(selectlist[1].value);		
		}				
		function removeOnClick()
		{
			Link.removeSelected(document.forms['project'].members);
		}
		
		function platformOnChange()
		{
			var frm = document.forms['project'];
			var platform = Platforms.getSelectedPlatform(frm.platform);
			var variant = Platforms.getSelectedVariant(frm.platform);
			var fileOnly = (variant != null && variant.fileOnly) || 
				(variant == null && platform != null && platform.fileOnly);
			var rawDataType = null;
			if (variant != null) 
			{
				rawDataType = variant.rawDataType;
			}
			else if (platform != null)
			{
				rawDataType = platform.rawDataType;
			}
			if (frm.rawdatatype[frm.rawdatatype.length - 1].value == '')
			{
				frm.rawdatatype[frm.rawdatatype.length - 1] = null;
			}
			if (fileOnly)
			{
				frm.rawdatatype.disabled = true;
				frm.rawdatatype[frm.rawdatatype.length] = new Option('- file only -', '');
				frm.rawdatatype.selectedIndex = frm.rawdatatype.length - 1;
			}
			else if (rawDataType)
			{
				frm.rawdatatype.disabled = true;
				Forms.selectListOption(frm.rawdatatype, rawDataType);
			}
			else
			{
				frm.rawdatatype.disabled = false;
				rawDataType = frm.rawdatatype[frm.rawdatatype.selectedIndex].value;
			}
			var icon = document.getElementById('icon_default_platform');
			var gif = getRoot()+'images/';
			if (!platform && !variant && !rawDataType)
			{
				gif += 'notrequired_novalues.gif';
			}
			else
			{
				gif += 'notrequired_values.gif';
			}
			icon.src = gif;
		}
		
		function rawDataTypeOnChange()
		{
			platformOnChange();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="project" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="autoPermissions" value="<%=PermissionUtil.getPermissionCode(project == null ? EnumSet.range(Permission.READ, Permission.DELETE): project.getAutoPermission())%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*320)+"px;"%>" 
			position="bottom" remember="<%=project != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Project" validate="validateProject()" helpid="project.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(project == null ? Values.getString(cc.getPropertyValue("name"), "New project") : project.getName())%>" 
					size="40" maxlength="<%=Project.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Default permissions</td>
				<td>
					<base:select 
						id="permissiontemplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentPermissionTemplate%>"
						denied="<%=!readCurrentPermissionTemplate%>"
						recent="<%=recentPermissionTemplates%>"
						newitem="<%=project == null%>"
						unselectedtext="- select a template or specify below -"
						onselect="selectPermissionTemplateOnClick()"
						onchange="permissionTemplateOnChange()"
					/>
				
					<input type="checkbox" checked name="auto_read" onClick="autoPermissionsOnClick('auto_read')">Read<br>
					<input type="checkbox" checked name="auto_use" onClick="autoPermissionsOnClick('auto_use')">Use<br>
					<input type="checkbox" name="auto_write" onClick="autoPermissionsOnClick('auto_write')">Write<br>
					<input type="checkbox" name="auto_delete" onClick="autoPermissionsOnClick('auto_delete')">Delete<br>
					<input type="checkbox" name="auto_set_owner" onClick="autoPermissionsOnClick('auto_set_owner')">Set owner<br>
					<input type="checkbox" name="auto_set_permission" onClick="autoPermissionsOnClick('auto_set_permission')">Set permission<br>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(project == null ? cc.getPropertyValue("description") : project.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'project', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="members" title="Members" validate="validateMembers()" helpid="project.edit.members">

		<table >
		<tr valign="top">
		<td>
			<b>Members</b><br>
			<select <%=clazz%> name="members" size="15" multiple onChange="membersOnChange()" 
				style="width: 22em;">
			</select>
			<input type="hidden" name="modifiedUsers" value="">
			<input type="hidden" name="modifiedGroups" value="">
		</td>
		<td>
			<br>
			<b>Permissions</b><br>
			<input type="checkbox" checked name="read" onClick="permissionsOnClick('read')">Read<br>
			<input type="checkbox" checked name="use" onClick="permissionsOnClick('use')">Use<br>
			<input type="checkbox" name="write" onClick="permissionsOnClick('write')">Write<br>
			<input type="checkbox" name="delete" onClick="permissionsOnClick('delete')">Delete<br>
			<input type="checkbox" name="set_owner" onClick="permissionsOnClick('set_owner')">Set owner<br>
			<input type="checkbox" name="set_permission" onClick="permissionsOnClick('set_permission')">Set permission<br>
		</td>
		<td>
			<br>
			<table width="150">
			<tr><td><base:button 
				onclick="addUsersOnClick()" 
				title="Add&nbsp;users&hellip;" 
				tooltip="Add users to this project"
				/></td></tr>
			<tr><td><base:button 
				onclick="addGroupsOnClick()" 
				title="Add&nbsp;groups&hellip;"  
				tooltip="Add groups to this project"
			/></td></tr>
			<tr><td><base:button 
				onclick="removeOnClick()" 
				title="Remove" 
				tooltip="Remove the selected items from this group"
			/></td></tr>
			</table>
		</td>
		</tr>
		</table>
		</t:tab>
		
		<t:tab id="defaults" title="Default items"  helpid="project.edit.defaults">
			<table class="form" cellspacing="2" border="0" cellpadding="0" width="100%">				
				<tr valign="top">
					<td width="40%">
						<b>Project defaults</b><br>
						<div class="parameterlist" style="height: <%=(int)(scale*260)%>px; width:<%=(int)(scale*200)%>px; margin-top: 4px;">
							<%=sb.toString()%>
						</div>
						<base:icon image="hasvalues.gif" /> = Has value
					</td>
					<td width="60%">
						<br>
						
						<div id="value_default_platform_div" style="display: none">
							<table>
							<tr>
								<td class="prompt">Platform</td>
							</tr>
							<tr>
								<td>
									<select name="platform" onchange="platformOnChange()">
									<option value="">- none -</option>
									</select>
								</td>
							</tr>
							<tr>
								<td class="prompt">Raw data type</td>
							</tr>
							<tr>
								<td>
									<select name="rawdatatype" onchange="rawDataTypeOnChange()">
									<option value="">- none -</option>
									<%
									for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
									{
										if (rdt.isStoredInDb())
										{
											String selected = rdt.equals(currentRawDataType) ? "selected" : "";
											%>
											<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
											<%
										}
									}
									%>
									</select>
								</td>
							</tr>
							</table>
							</div>
						
						<%
						for (Project.Default d : Project.Default.values())
						{
							String inputName = "value_" + d.getName();
							if (!ignore.contains(d))
							{
								%>
								<div id="<%=inputName%>_div" style="display: none;">
									<table>
										<tr>
										<td class="prompt"><%=d.getShortName()%></td>
										</tr>
										<%
										if (d.getItemType() != null)
										{
											String selectDefaultItemOnClick = "";
											String defaultItemOnChange = "";	
											List recentItems = null;
											boolean readCurrentItem = true;
											BasicItem currentItem = null;
											try
											{
												currentItem = project != null ? project.getDefaultItem(dc, d) : null;
											}
											catch (PermissionDeniedException ex)
											{
												readCurrentItem = false;
											}
											
											if (d.getItemType() == Item.PROTOCOL) 
											{
												int typeId = SystemItems.getId(d.getType());
												String url = "'../../admin/protocols/index.jsp?ID=" + ID + 
														"&cmd=UpdateContext&mode=selectone&callback=setDefaultItemCallback" +
														"&resetTemporary=1&tmpfilter:INT:protocolType=" + typeId + "'";
												selectDefaultItemOnClick = "selectDefaultItemOnClick(" + url + ")";
												recentItems = recentProtocol;
											}
											else if (d.getItemType() == Item.HARDWARE)
											{
												int typeId = SystemItems.getId(d.getType());
												String url = "'../../admin/hardware/index.jsp?ID=" + ID + 
														"&cmd=UpdateContext&mode=selectone&callback=setDefaultItemCallback" +
														"&resetTemporary=1&tmpfilter:INT:hardwareType=" + typeId + "'";
												selectDefaultItemOnClick = "selectDefaultItemOnClick(" + url + ")";
												recentItems = recentHardware;
											}
											else if (d.getItemType() == Item.SOFTWARE)
											{
												String url = "'../../admin/software/index.jsp?ID=" + ID + 
														"&cmd=UpdateContext&mode=selectone&callback=setDefaultItemCallback'";
												selectDefaultItemOnClick = "selectDefaultItemOnClick(" + url + ")";
												recentItems = recentSoftware;
											}
											else if (d.getItemType() == Item.ARRAYDESIGN)
											{
												String url = "'../../lims/arraydesigns/index.jsp?ID=" + ID + 
														"&mode=selectone&callback=setDefaultItemCallback'";
												selectDefaultItemOnClick = "selectDefaultItemOnClick(" + url + ")";									
												recentItems = recentArrayDesign;
											}								
											%>		
											<tr>
											<td>
												<base:select 
													id="<%=inputName%>"
													clazz="selectionlist"
													required="false"
													current="<%=currentItem%>"
													denied="<%=!readCurrentItem%>"
													recent="<%=recentItems%>"
													newitem="<%=project == null%>"
													onselect="<%=selectDefaultItemOnClick%>"
													onchange = 'defaultValueOnChange(this[this.selectedIndex].value)'
												/>
											</td>
											</tr>									
										<%
										}
										%>
									</table>										
								</div>
								<%
							}
						}
						%>						
					</td>
				</tr>
			</table>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
